#include <stdio.h>
#include <stdlib.h>

char* FILE_read(FILE* fp) {
    static const int BUFLEN = 4096;
    char* r = NULL;
    long cur, len = 0;
    cur = ftell(fp);
    if (fseek(fp, 0, SEEK_END) || !ftell(fp)) {
        char buf[BUFLEN];
        while ((cur = fread(buf, 1, BUFLEN, fp)) == BUFLEN) {
            r = realloc(r, len+BUFLEN);
            memcpy(r+len, buf, BUFLEN);
            len += BUFLEN;
        }
        r = realloc(r, len+cur+1);
        memcpy(r+len, buf, cur);
        len += cur;
        r[len] = '\0';
        return r;
    }
    else {
        len = ftell(fp) - cur;
        fseek(fp, cur, SEEK_SET);
        r = malloc(len+1);
        fread(r, 1, len, fp);
        return r;
    }
}

char* file_read(const char* fname) {
    FILE* fp = fopen(fname, "r");
    char* r = FILE_read(fp);
    fclose(fp);
    return r;
}
